searchNodes=[{"doc":"A behaviour for the AMQP client implementation. This module declares a behaviour for the AMQP library, allowing us to use different implementations of the underlaying AMQP interface. Check out the AMQPHelpers.Adapters.Stub and AMQPHelpers.Adapters.AMQP for actual implementations of this behaviour. This behaviour also enables us to mock this interface in tests using libraries like Mox . Check out the libraries tests for examples about this usage.","ref":"AMQPHelpers.Adapter.html","title":"AMQPHelpers.Adapter","type":"behaviour"},{"doc":"Acknowledges one or more messages. See AMQP.Basic.ack/3 .","ref":"AMQPHelpers.Adapter.html#c:ack/3","title":"AMQPHelpers.Adapter.ack/3","type":"callback"},{"doc":"Stops the given consumer from consuming. See AMQP.Basic.cancel/3 .","ref":"AMQPHelpers.Adapter.html#c:cancel_consume/3","title":"AMQPHelpers.Adapter.cancel_consume/3","type":"callback"},{"doc":"Closes an open Channel. See AMQP.Channel.close/1 .","ref":"AMQPHelpers.Adapter.html#c:close_channel/1","title":"AMQPHelpers.Adapter.close_channel/1","type":"callback"},{"doc":"Registers a queue consumer process. See AMQP.Basic.consume/4 .","ref":"AMQPHelpers.Adapter.html#c:consume/4","title":"AMQPHelpers.Adapter.consume/4","type":"callback"},{"doc":"Activates publishing confirmations on the channel. See AMQP.Confirm.select/1 .","ref":"AMQPHelpers.Adapter.html#c:enable_select_confirm/1","title":"AMQPHelpers.Adapter.enable_select_confirm/1","type":"callback"},{"doc":"Provides an easy way to access an AMQP.Channel.t/0 . See AMQP.Application.get_channel/1 .","ref":"AMQPHelpers.Adapter.html#c:fetch_application_channel/1","title":"AMQPHelpers.Adapter.fetch_application_channel/1","type":"callback"},{"doc":"Provides an easy way to access an AMQP.Connection.t/0 . See AMQP.Application.get_connection/1 .","ref":"AMQPHelpers.Adapter.html#c:fetch_application_connection/1","title":"AMQPHelpers.Adapter.fetch_application_connection/1","type":"callback"},{"doc":"Returns the next message sequence number. See AMQP.Confirm.next_publish_seqno/1 .","ref":"AMQPHelpers.Adapter.html#c:get_next_delivery_tag/1","title":"AMQPHelpers.Adapter.get_next_delivery_tag/1","type":"callback"},{"doc":"Negative acknowledges of one or more messages. See AMQP.Basic.nack/3 .","ref":"AMQPHelpers.Adapter.html#c:nack/3","title":"AMQPHelpers.Adapter.nack/3","type":"callback"},{"doc":"Opens a new channel in a previously opened connection. See AMQP.Channel.open/2 .","ref":"AMQPHelpers.Adapter.html#c:open_channel/1","title":"AMQPHelpers.Adapter.open_channel/1","type":"callback"},{"doc":"Publishes a message to an Exchange. See AMQP.Basic.publish/5 .","ref":"AMQPHelpers.Adapter.html#c:publish/5","title":"AMQPHelpers.Adapter.publish/5","type":"callback"},{"doc":"Register a handler for confirms on channel. See AMQP.Confirm.register_handler/2 .","ref":"AMQPHelpers.Adapter.html#c:register_confirm_handler/2","title":"AMQPHelpers.Adapter.register_confirm_handler/2","type":"callback"},{"doc":"Registers a handler to deal with returned messages. See AMQP.Basic.return/2 .","ref":"AMQPHelpers.Adapter.html#c:register_return_handler/2","title":"AMQPHelpers.Adapter.register_return_handler/2","type":"callback"},{"doc":"Sets the message prefetch count or prefetch size. See AMQP.Basic.qos/2 .","ref":"AMQPHelpers.Adapter.html#c:set_channel_options/2","title":"AMQPHelpers.Adapter.set_channel_options/2","type":"callback"},{"doc":"A AMQPHelpers.Adapter which relies in AMQP lib. This module uses AMQP to implement the AMQPHelpers.Adapter . This is probably the adapter that you want to use for production or integration tests because it uses the actual AMQP interface.","ref":"AMQPHelpers.Adapters.AMQP.html","title":"AMQPHelpers.Adapters.AMQP","type":"module"},{"doc":"A AMQPHelpers.Adapter which just logs. This module implements a stub for AMQPHelpers.Adapter which mainly logs calls. You probably want to use this for non-integration testing or a development environment without a AMQP broker.","ref":"AMQPHelpers.Adapters.Stub.html","title":"AMQPHelpers.Adapters.Stub","type":"module"},{"doc":"Utilities for dealing with high-throughput scenarios. This module provides a couple of functions which enforce some options to achieve good results on high throughput scenarios. Review the High Throughput section for more information.","ref":"AMQPHelpers.HighThroughput.html","title":"AMQPHelpers.HighThroughput","type":"module"},{"doc":"Registers a queue consumer process. Like AMQP.Basic.consume/4 but enforces options which play nicely with a high throughput scenario.","ref":"AMQPHelpers.HighThroughput.html#consume/5","title":"AMQPHelpers.HighThroughput.consume/5","type":"function"},{"doc":"Publishes a message to an Exchange. Like AMQP.Basic.publish/5 but enforces options which play nicely with a high throughput scenario.","ref":"AMQPHelpers.HighThroughput.html#publish/6","title":"AMQPHelpers.HighThroughput.publish/6","type":"function"},{"doc":"A remote procedure call implementation. This module provide a helper function which implements the RPC pattern using the Direct Reply-to . This allows a client to send a request and receive a response synchronously, without having to manage any response queue.","ref":"AMQPHelpers.RPC.html","title":"AMQPHelpers.RPC","type":"module"},{"doc":"Executes a remote procedure call. This function sends the given messages and waits for a response using Direct Reply-to . This function uses a Task internally to wait for responses. This means all the caveats and OTP compatibility Task issues apply here too. Check call_nolink/7 for more information.","ref":"AMQPHelpers.RPC.html#call/6","title":"AMQPHelpers.RPC.call/6","type":"function"},{"doc":"Executes a remote procedure call without linking to the calling process. Like call/6 but it does not link the waiting process to the calling process. Check Task.Supervisor for more information.","ref":"AMQPHelpers.RPC.html#call_nolink/7","title":"AMQPHelpers.RPC.call_nolink/7","type":"function"},{"doc":"A consumer for dealing with reliability scenarios. A AMQPHelpers.Reliability.Consumer is process which manages a reliable consume operation over AMQP , where messages are acknowledge to the broker after processing them. Pair this process with a AMQPHelpers.Reliability.Producer to provide reliable message exchange. Example This Consumer delivers messages to a message_handler/0 which processes these messages. The Consumer enforces the usage of AMQP.Application , so after defining our application connection, channels and our message handler we can create an instance of this process using start_link/1 to start consuming messages: alias AMQPHelpers.Reliability.Consumer my_message_handler = fn payload , meta -&gt; IO . inspect ( { payload , meta } , label : &quot;Got a message!&quot; ) end { :ok , consumer } = Consumer . start_link ( channel_name : :my_channel_name , message_handler : :my_channel_name , queue_name : &quot;my_queue_name&quot; )","ref":"AMQPHelpers.Reliability.Consumer.html","title":"AMQPHelpers.Reliability.Consumer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"AMQPHelpers.Reliability.Consumer.html#child_spec/1","title":"AMQPHelpers.Reliability.Consumer.child_spec/1","type":"function"},{"doc":"Starts consuming messages. This function is used to start consuming messages when consume_on_init option is set to false. Not required by default but useful for testing purposes.","ref":"AMQPHelpers.Reliability.Consumer.html#consume/1","title":"AMQPHelpers.Reliability.Consumer.consume/1","type":"function"},{"doc":"Starts a Consumer process linked to the current process. Options The following option can be given to Consumer when starting it. Note that message_handler and queue_name are required . adapter - Sets the AMQPHelpers.Adapter . Defaults to AMQPHelpers.Adapters.AMQP . channel - The channel to use to consume messages. NOTE : do not use this for production environments because this Consumer does not supervise the given channel. Instead, use channel_name which makes use of AMQP.Application . channel_name - The name of the configured channel to use. See AMQP.Application for more information. Defaults to :default . consume_on_init - If the consumer should start consuming messages on init or not. Defaults to true . consume_options - The options given to AMQPHelpers.Adapter.consume/4 . message_handler - The function that will deal with messages. Required. prefetch_count - The maximum number of unacknowledged messages in the channel. See AMQP.Basic.qos2 for more info. prefetch_size - The maximum number of unacknowledged bytes in the channel. See AMQP.Basic.qos2 for more info. queue_name - The name of the queue to consume. Required. requeue - Whether to requeue messages or not after a consume error. Defaults to true . retry_interval - The number of millisecond to wait if an error happens when trying to consume messages or when trying to open a channel. shutdown_gracefully - If enabled, the consumer will cancel the subscription when terminating. Default to false but enforced if consumer_options has exclusive set to true . task_supervisor - The Task.Supervisor which runs message handling tasks. If not provided, the Consumer will handle messages synchronously. GenServer.options/0 are also available. See GenServer.start_link/2 for more information about these.","ref":"AMQPHelpers.Reliability.Consumer.html#start_link/1","title":"AMQPHelpers.Reliability.Consumer.start_link/1","type":"function"},{"doc":"The function that handle messages. A message handler is a function that will deal with the consumed messaged. It will receive the payload of the message as first argument, and the message metadata as second argument. A module, function, arguments triplet can also be used. For example, if {Foo, :bar, [1, 2]} is used as message handler, the consumer will call Foo.bar(message, meta, 1, 2) to handle messages. This function must return :ok if the messages was handled successfully, so the consumer will acknowledge the message. Any other return value will non-acknowledge the message.","ref":"AMQPHelpers.Reliability.Consumer.html#t:message_handler/0","title":"AMQPHelpers.Reliability.Consumer.message_handler/0","type":"type"},{"doc":"Option values used by start_link/1 function.","ref":"AMQPHelpers.Reliability.Consumer.html#t:option/0","title":"AMQPHelpers.Reliability.Consumer.option/0","type":"type"},{"doc":"Options used by start_link/1 function.","ref":"AMQPHelpers.Reliability.Consumer.html#t:options/0","title":"AMQPHelpers.Reliability.Consumer.options/0","type":"type"},{"doc":"A producer for dealing with reliability scenarios. A AMQPHelpers.Reliability.Producer is process which manages a reliable send operation over AMQP , where messages are acknowledge by the broker after sending them. Publisher Confirms AMQP extension is used to achieve this. Example This Producer enforces the usage of AMQP.Application , so after defining our application connection and channel we can start a producer and start publishing message in a reliable way. alias AMQPHelpers.Reliability.Producer { :ok , producer } = Consumer . start_link ( channel_name : :my_channel_name ) Producer . publish ( producer , &quot;exchange&quot; , &quot;routing_key&quot; , &quot;payload&quot; , message_id : &quot;foo&quot; )","ref":"AMQPHelpers.Reliability.Producer.html","title":"AMQPHelpers.Reliability.Producer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"AMQPHelpers.Reliability.Producer.html#child_spec/1","title":"AMQPHelpers.Reliability.Producer.child_spec/1","type":"function"},{"doc":"Publish a message ensuring that the broker receives it. Similar to AMQPHelpers.Adapter.publish/5 but ensures that the broker receives the message sent. Some message delivery options are enabled by default ( mandatory and persistent ) and message_id option is required to track the message state.","ref":"AMQPHelpers.Reliability.Producer.html#publish/6","title":"AMQPHelpers.Reliability.Producer.publish/6","type":"function"},{"doc":"Setups the channel for reliable message delivery. This function is used to setup reliable message delivery when setup_channel_on_init is set to false. Not required by default but useful for testing purposes.","ref":"AMQPHelpers.Reliability.Producer.html#setup_channel/1","title":"AMQPHelpers.Reliability.Producer.setup_channel/1","type":"function"},{"doc":"Starts a Producer process linked to the current process. Options The following option can be given to Producer when starting it. Note that queue_name is required . adapter - Sets the AMQPHelpers.Adapter . Defaults to AMQPHelpers.Adapters.AMQP . setup_channel_on_init - Whether to configure the channel for reliable message sending on init or not. Defaults to false . channel - The channel to use to consume messages. NOTE : do not use this for production environments because this producer does not supervise the given channel. Instead, use channel_name which makes use of AMQP.Application . channel_name - The name of the configured channel to use. See AMQP.Application for more information. Defaults to :default . retry_interval - The number of millisecond to wait if an error happens when trying to consume messages or when trying to open a channel. GenServer.options/0 are also available. See GenServer.start_link/2 for more information about these.","ref":"AMQPHelpers.Reliability.Producer.html#start_link/1","title":"AMQPHelpers.Reliability.Producer.start_link/1","type":"function"},{"doc":"Option values used by start_link/1 function.","ref":"AMQPHelpers.Reliability.Producer.html#t:option/0","title":"AMQPHelpers.Reliability.Producer.option/0","type":"type"},{"doc":"Options used by start_link/1 function.","ref":"AMQPHelpers.Reliability.Producer.html#t:options/0","title":"AMQPHelpers.Reliability.Producer.options/0","type":"type"},{"doc":"AMQP Helpers Non opinionated AMQP helpers for common scenarios.","ref":"readme.html","title":"AMQP Helpers","type":"extras"},{"doc":"To use AMQPHelpers you need AMQP . You can install both by adding amqp and amqp_helpers to your list of dependencies in mix.exs : def deps do [ { :amqp , &quot;~&gt; 3.0&quot; } , { :amqp_helpers , &quot;~&gt; 1.1&quot; } ] end","ref":"readme.html#installation","title":"AMQP Helpers - Installation","type":"extras"},{"doc":"This library provides several wrappers and utilities around some common use cases of AMQP . It provides a simple interface, following common OTP patterns and Elixir library guidelines to avoid any opinionated interface. Other generalist abstractions can be built on top of AMQPHelpers to provide ergonomics or any other feature not strictly tied to AMQP . Right now, the utilities built in this library are suited for uses that try to optimize AMQP for high throughput and for scenarios that require data safety at any cost. Comparisons With Other Libraries This is how this library relates to other available libraries in order to highlight the motivation behind this library: AMQP : this library is not a replacement in any way to this library, but a companion. AMQPx : in some way, similar to this library, but not tied to any particular use case and some of its functionality has been superseded by AMQP v2.x. Broadway : this is an abstraction for message processing, which cannot be compared directly to this library. broadway_rabbitmq is a connector for AMQP and can be adapted to use this library if needed. Nevertheless, unless you want to support multiple transports, most of the features provided by Broadway can be implemented directly by using some RabbitMQ / AMQP features (there are exceptions like graceful shutdown). GenAmqp : provides some utilities in the same way that this library, but not tied to any specific use case. Also, some of its functionality has been superseded by AMQP v2.x. PlugAmqp : It will use this library, but have different purposes (it implements RPC pattern over AMQP ). Rambla : similar to Broadway , but from the publishing point of view. In summary, this library provides helpers tied to specific use cases of AMQP , without any kind of abstraction over it. If you are looking to support different kinds of transports in your library, check out libraries like Broadway or Rambla .","ref":"readme.html#motivation","title":"AMQP Helpers - Motivation","type":"extras"},{"doc":"This library enforces some good practices that have no downside for any application using AMQP and ease the development of AMQP related features. The first one is the use of an AMQP implementation behind a behaviour, called AMQPHelpers.Adapter . This allow us to provide stub, mocks or even different transport layers that mimic the AMQP interface. The second one is the use of application connection/channels . This an AMQP v2.x feature which replaces (or aid) previous connections supervisors or channel pools. As general thumb rule, your application should have at most two connection (in/out) and one channel per multiplexing process.","ref":"readme.html#amqp-good-practices","title":"AMQP Helpers - AMQP Good Practices","type":"extras"},{"doc":"These are the AMQP use cases are covered in AMQP Helpers right now: A performance-intensive scenario in which a high throughput message delivery rate is desired. Trade-offs in reliability are acceptable. A reliable scenario in which data safety is a must, even if performance is compromised. Remote procedure calls using Direct Reply-to . There are some other features, like High Availability , Observability , Exclusivity , etc. that can be achieved in both scenarios but are not explicitly covered here. High Throughput To achieve the best performance in terms of message delivery some trade-off must be done, which usually impacts the reliability and/or coherence of the system. Durability should be disabled. In other words, messages will not be persisted, so messages could be lost in a broker outage scenario. This can be configured by declaring queues as non-durable and publishing messages with persistent set to false . Acknowledges, from any communication direction, should be disabled. This means that the publisher should not confirm deliveries, and consumers should not acknowledge messages. Messages could be lost on the flight because of network or edge issues. Publisher confirms are not enabled by default, so nothing has to be done in terms of publishing. Consuming requires disabling acknowledging, which can be done by setting the no_ack flag on. The AMQPHelpers.HighThroughput module provides functions that enforce these requirements for publishing and consuming. These are simple wrappers around AMQP library functions. They add very little aside from being explicit about a feature of some scenario (performance intensive). Some other considerations should have taken into account when declaring queues for this purpose, which are: x-max-length or x-max-length-bytes with x-expires and x-messages-ttl should be used to avoid large queues. Large queues slowdown message delivery. This option limits the size of the queue to a known threshold. x-queue-mode should not be &quot;lazy&quot; to avoid moving messages to disk. Queues should not be replicated, nor enabling high availability nor using quorum queues . Both method have implications in the performance of the queue. durable should be set to false . Reliability For reliability, Acknowledgements and Confirms are used, which have an impact in performance. Reliability is not only achieved at client level, broker configuration and monitoring are also important topics here. You can read RabbitMQ's Reliability Guide for more information. The AMQPHelpers.Reliability.Consumer and AMQPHelpers.Reliability.Producer provide processes to consume and publish messages in a reliable fashion. The Consumer uses standard AMQP acknowledges mechanism to notify that messages are consumed successfully. The Producer uses the Publisher Confirms extension to get notified about successfully message deliveries. A system which uses the provided Reliability.Consumer and Reliability.Producer will guarantee that no message is lost, and at least one message is delivered. For high availability you can pair this processes with mirrored queues. For consistency, you can use deduplication plugin or quorum queues (Which also guarantees message order).","ref":"readme.html#user-case-scenarios","title":"AMQP Helpers - User Case Scenarios","type":"extras"},{"doc":"This library provides an AMQP interface at AMQPHelpers.Adapter which can be used with libraries like Mox to mock any part of the AMQP interface. Check out the tests of this library to see some examples. Two adapter implementations are provided with this library: AMQPHelpers.Adapters.Stub - A stub implementation that only logs calls. AMQPHelpers.Adapters.AMQP - An implementation that uses AMQP library. All the functionally exposed by the library support in one or another way a configurable adapter (defaults to AMQP implementation).","ref":"readme.html#testing","title":"AMQP Helpers - Testing","type":"extras"},{"doc":"CloudAMQP - RabbitMQ Best Practices for High Availability CloudAMQP - RabbitMQ Best Practices for High Performance CloudAMQP - RabbitMQ Best Practices RabbitMQ Docs - Reliability Guide RabbitMQ in Depth","ref":"readme.html#references","title":"AMQP Helpers - References","type":"extras"}]